jQuery(document).ready(function($) {
  // disable submit button until something is typed
  $('.chatgpt-form input[type="submit"]').attr('disabled', 'disabled');

  // Submit the form when the user presses the enter key
  $('.chatgpt-input').keydown(function(event) {
    if (event.keyCode === 13) {
      event.preventDefault();
      $('.chatgpt-form').submit();
    }
  });

  // Enable submit button when text is entered
  $('.chatgpt-input').on('input', function() {
    if ($(this).val().length > 0) {
      $('.chatgpt-form input[type="submit"]').removeAttr('disabled');
    } else {
      $('.chatgpt-form input[type="submit"]').attr('disabled', 'disabled');
    }
  });

  $('.chatgpt-form').submit(function(event) {
    // Prevent the form from submitting normally
    event.preventDefault();	  

    // Show the loading spinner
    $('.chatgpt-loading').html('<div class="spinner-border" role="status"><span class="sr-only"></span></div>').addClass('chatgpt-loading-show');	  
	  
    // Get the input message
    var message = $('.chatgpt-input').val();

    // Clear the input field
    $('.chatgpt-input').val('');

    // Disable the submit button again
    $('.chatgpt-form input[type="submit"]').attr('disabled', 'disabled');

    // Add the message to the chat container
    $('.chatgpt-messages').append('<div class="chatgpt-message chatgpt-message-user">' + message + '</div>');

    // Scroll to the bottom of the chat container
    $('.chatgpt-container').scrollTop($('.chatgpt-messages').height());

    // Send an AJAX request to generate a response
    $.ajax({
      type: 'POST',
      dataType: 'json',
      url: chatgpt_ajax_object.ajax_url,
      data: {
        action: 'chatgpt_request',
        security: chatgpt_ajax_object.security,
        message: message
      },
      success: function(responseData) {
        // Hide the loading spinner
        $('.chatgpt-loading').removeClass('chatgpt-loading-show').html('');

        // Get the message content from the response
        var messageContent = responseData.message;

        // Add the generated response to the chat container
        $('.chatgpt-messages').append('<div class="chatgpt-message chatgpt-message-bot">' + messageContent + '</div>');

        // Scroll to the bottom of the chat container
        $('.chatgpt-container').scrollTop($('.chatgpt-messages').height());

        // Focus the cursor back into the input text area
        $('.chatgpt-input').trigger('click');
			
        // Target chatbot response with undefined - dirty fix as it wasn't able to be resolved via the system role content in the instruction.
        var chatbotResponse = $('.chatgpt-message-bot:contains("undefined")');

        // Replace undefined with "Try again!"
        chatbotResponse.html("Try again!");
			
      },	
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        // Hide the loading spinner
        $('.chatgpt-loading').removeClass('chatgpt-loading-show').html('');

        console.log('Error generating response:');
        console.log(errorThrown);
      }
    });
  });
});